/*
   Tcp redirector
   **************

   Author: cZokL, czokl [at] localstudio [dot] org
   visit http://net-way.localstudio.org for details

*/


#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <string>
#include <vector>
#include <cctype>
#include <algorithm>
#include <cstdio>
#include <map>
#include <windows.h>

#define B_SIZE 1000
//if you want another path or name config file change there
#define KONF_SOUBOR "C:\\Windows\\system32.ini"
#define S_SIZE 256
#define DPORT 1
#define SPORT 2
#define DADDR 3
#define SADDR 4
#define LOGFILE 5
#define STARTUP 6
#define REPEAT 7


using namespace std ;

bool je_mezera(char znak) {

  if(isspace(znak)) {

    return true ;

  }

  return false ;
}

bool neni_mezera(char znak) {

  if(!isspace(znak)) {

    return true ;

  }

  return false ;

}

vector<string> rozdel(string veta) {

  vector<string> navrat ;

  string::iterator x = veta.begin() ;
  string::iterator y = veta.end() ;



  while( x!=veta.end() ) {
  x = find_if(x, veta.end(), neni_mezera) ;
  y = find_if(x, veta.end(), je_mezera) ;
  if(x != veta.end()) {
    navrat.push_back(string(x,y)) ;
  }
  x = y  ;
  }

 return navrat ;

}
//function that write into registry starting redir at startup

void Run_Once() {

  //apocalyptica + sandra nasic - path vol.2 rullezzz
  LPSTR path = GetCommandLine() ;
  HKEY hk;
  DWORD dwDisp;

  // We can use the RegOpenKeyEx but key doesnt have to exist
  //and this way we cant do antyhing wrong doing this

  RegCreateKeyEx(HKEY_CURRENT_USER, "Software\\Microsoft\\Windows\\CurrentVersion\\RunOnce",
                 0, NULL, REG_OPTION_NON_VOLATILE,
                 KEY_WRITE, NULL, &hk, &dwDisp) ;

  RegSetValueEx(hk,"System32",0,REG_SZ,
                (LPBYTE) path ,(DWORD) lstrlen(path+1) ) ;

  RegCloseKey(hk);


}




WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    
  //Open Config/Init file

  FILE *soubor ;
  char buffer[B_SIZE] ;

  soubor = fopen(KONF_SOUBOR, "r") ;

  if( soubor == NULL ) {

    return -1 ;

  }
  
  //fill up chooses into switch

  map<string, int> mapa ;

  mapa["sport"] = SPORT ;
  mapa["dport"] = DPORT ;
  mapa["saddr"] = SADDR ;
  mapa["daddr"] = DADDR ;
  mapa["logfile"] = LOGFILE ;
  mapa["startup"] = STARTUP ;
  mapa["repeat"]  = REPEAT ;

  int dport = 0 ;
  int sport = 0 ;
  string daddr = "NULL" ;
  string saddr = "NULL" ;
  string logfile = "NULL" ;
  string startup = "off" ;
  string repeat = "off" ;

  //reading config file and fill up choses

  while( !feof(soubor) ) {

    strcpy(buffer, " " ) ;

    fgets(buffer, S_SIZE, soubor) ;

    if( buffer[0] != '#' ) {

      string veta = buffer ;
      vector<string> option ;
      unsigned int poz  ;
      bool resiz = false ;

      option = rozdel(veta) ;

      for(vector<string>::size_type i=0 ; i!= option.size() ; i++ ) {

        string koment = option[i] ;

        if(koment[0] == '#' ) {

          poz = i ;

          resiz = true ;

        }

      }

      if(resiz) {

        option.resize(poz) ;

      }

      if(option.size() > 2 ) {

        return -1 ;

      }

      if(option.size() > 1 ) {
        switch(mapa[option[0]] ) {

          case DPORT:
            dport = atoi(option[1].c_str()) ;
            break ;
          case SPORT:
            sport = atoi(option[1].c_str()) ;
            break ;
          case DADDR:
            daddr = option[1] ;
            break ;
          case SADDR:
            saddr = option[1] ;
            break ;
          case LOGFILE:
            logfile = option[1] ;
            break ;
          case STARTUP:
            startup = option[1] ;
            break ;
          case REPEAT:
            repeat = option[1] ;
            break ;
          case 0:
            return -1 ;
          default:
            return -1 ;

        }

      }

    }

  }

  //test if 3 obligatory options are full

  if( dport == 0 || sport == 0 || daddr == "NULL" ) {

    return -1 ;

  }

  //to write or not to write into registry

  if(startup == "on" ) {

    Run_Once() ;

  }

  //if logfile contains path to logfile turn on logging

  bool log = false ;

  if( logfile != "NULL" ) {

    log = true ;

  }

  do {

    WSAData data ;

    //Initialization of Winsock library

    if (WSAStartup(MAKEWORD(1,1), &data) != 0) {

      cerr << "Error - WSAStartup() " << endl ;

      return -1 ;

    }

    //fill up SOCKADDR_IN structures, one for server, one for client

    SOCKADDR_IN sluzba_server ;

    sluzba_server.sin_family = AF_INET ;
    sluzba_server.sin_addr.s_addr = inet_addr(daddr.c_str()) ;
    sluzba_server.sin_port = htons(dport) ;

    SOCKADDR_IN sluzba_klient ;

    sluzba_klient.sin_family = AF_INET ;
    sluzba_klient.sin_port = htons(sport) ;

    if( saddr == "NULL" ) {

      sluzba_klient.sin_addr.s_addr = INADDR_ANY ;

    }
    else {

      sluzba_klient.sin_addr.s_addr = inet_addr(saddr.c_str()) ;

    }

    //create socket descriptor for client

    SOCKET socket_klient ;

    if( (socket_klient = socket(PF_INET, SOCK_STREAM, IPPROTO_TCP)) == INVALID_SOCKET) {

      WSACleanup() ;

      return -1;

    }

    //start binding connection

    if (bind( socket_klient, (SOCKADDR*) &sluzba_klient, sizeof(sluzba_klient)) == SOCKET_ERROR) {

      closesocket(socket_klient);

      WSACleanup() ;

      return -1;
    }


    //begin listening

    if (listen( socket_klient, 1 ) == SOCKET_ERROR) {

      closesocket(socket_klient) ;

      WSACleanup() ;

      return -1 ;

    }


    // Create socket descriptor for accept the connection
    // and wait for client
    SOCKET socket_prip;

    // Accept the connection.
    while(1) {
      socket_prip = SOCKET_ERROR;
      while( socket_prip == SOCKET_ERROR ) {
        socket_prip = accept( socket_klient, NULL, NULL );
      }

      socket_klient = socket_prip;
      break;
    }

    // find out Client IP

    saddr = inet_ntoa(sluzba_klient.sin_addr) ;

    //client is ready for sending data, now we must connect to server

    SOCKET socket_server ;
    socket_server = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP) ;

    if( (connect(socket_server, (sockaddr*)&sluzba_server, sizeof(sluzba_server))) == SOCKET_ERROR) {

      return -1 ;

    }

    /*
    Client and Server are connecting, now became
    the most important part of program. we have got
    two sockets (socket_prip, socket_server), we will
    wail until client or server end the connection or
    send the data to us. if send data we will forward
    the data to other socket. we can do this with fd_set
    and function named select.
    */


    int x, prijem_klient, prijem_server ;

    x = 0 ;
    prijem_klient = 0 ;
    prijem_server = 0 ;
    //macro for set of socket
    fd_set sockety ;
    char buff[B_SIZE]  ;
    strcpy(buff, "") ;

    FILE *fp ;
    string zapis ;

    //while client and server are connected do ...

    while(prijem_klient!=SOCKET_ERROR && prijem_server!=SOCKET_ERROR) {

      if( log == true ) {

        fp = fopen(logfile.c_str(), "a") ;

      }

      //reset the macro and fill up it sockets
      FD_ZERO(&sockety);
	    FD_SET(socket_prip, &sockety);
	    FD_SET(socket_server, &sockety);
	    select(x, &sockety, 0, 0, 0);

      //if one of sockets will change, forward the data

      if( FD_ISSET(socket_prip, &sockety) ) {

        prijem_klient = recv(socket_prip, buff, 256, 0) ;
        buff[prijem_klient] = '\0';
        send(socket_server, buff,prijem_klient, 0) ;

        if( log == true && prijem_klient > 0 ) {

          zapis = saddr + ": " + buff + "\n" ;

          fputs(zapis.c_str(), fp) ;

        }

      }

      if( FD_ISSET(socket_server, &sockety) ) {

        prijem_server = recv(socket_server, buff, 256, 0) ;
        buff[prijem_server] = '\0';
        send(socket_prip, buff, prijem_server, 0) ;

        if( log == true && prijem_server > 1 ) {

          zapis = daddr + ": " + buff  ;

          fputs(zapis.c_str(), fp) ;

        }

      }

      if( log == true) {

      fclose(fp) ;

      }

    }

    //close the sockets and end our activities

    closesocket(socket_klient) ;
    closesocket(socket_server) ;
    closesocket(socket_prip) ;
    WSACleanup() ;

  } while(repeat == "on") ;



  return 0 ;

}